#include <iostream>

#include "Translate.h"

using namespace std;

int main()
{
    clog << "ImpExp hello!!!" << endl << endl;
    
    Translate TT;
    Handle(TopTools_HSequenceOfShape) shapes;
	
	// *** Import ***
	
    shapes = TT.importModel( FormatBREP, "Input/wing.brep" );
    
	// --- Process shapes ---

	ShapeExtend_Explorer Explorer;
	
	Handle (TopTools_HSequenceOfShape) vertices;
	Handle (TopTools_HSequenceOfShape) edges;
	Handle (TopTools_HSequenceOfShape) wires;
	Handle (TopTools_HSequenceOfShape) faces;
	Handle (TopTools_HSequenceOfShape) shells;
	Handle (TopTools_HSequenceOfShape) solids;
	Handle (TopTools_HSequenceOfShape) compsols;
	Handle (TopTools_HSequenceOfShape) compounds; 
	
	Explorer.DispatchList(shapes, vertices, edges, wires, faces, shells, solids, compsols, compounds); 	
	
	// more processing ...

	// --- End process shapes ---
	
    // *** Export ***
	
    clog << endl << "FormatBREP: wing.brep" << endl;
    TT.exportModel( FormatBREP, "Output/wing.brep", shapes );
    
	clog << endl << "FormatIGES: wing.iges" << endl;
    TT.exportModel( FormatIGES, "Output/wing.iges", shapes );
    
	clog << endl << "FormatSTEP: wing.step" << endl;
    TT.exportModel( FormatSTEP, "Output/wing.step", shapes );
    
	clog << endl << "FormatSTL: wing.stl" << endl;
    TT.exportModel( FormatSTL, "Output/wing.stl", shapes );
	
	clog << endl << "FormatVRML: wing.wrl" << endl;
	TT.exportModel( FormatVRML, "Output/wing.wrl", shapes );
	
	// *** Import ***
	
    shapes = TT.importModel( FormatIGES, "Input/hammer.iges" );
    
    // *** Export ***
	
    clog << endl << "FormatBREP: hammer.brep" << endl;
    TT.exportModel( FormatBREP, "Output/hammer.brep", shapes );
    
	clog << endl << "FormatIGES: hammer.iges" << endl;
    TT.exportModel( FormatIGES, "Output/hammer.iges", shapes );
    
	clog << endl << "FormatSTEP: hammer.step" << endl;
    TT.exportModel( FormatSTEP, "Output/hammer.step", shapes );
    
	clog << endl << "FormatSTL: hammer.stl" << endl;
    TT.exportModel( FormatSTL, "Output/hammer.stl", shapes );
	
	clog << endl << "FormatVRML: hammer.wrl" << endl;
	TT.exportModel( FormatVRML, "Output/hammer.wrl", shapes );
	
	// *** Import ***
	
    shapes = TT.importModel( FormatSTEP, "Input/linkrods.step" );
    
    // *** Export ***
	
    clog << endl << "FormatBREP: linkrods.brep" << endl;
    TT.exportModel( FormatBREP, "Output/linkrods.brep", shapes );
    
	clog << endl << "FormatIGES: linkrods.iges" << endl;
    TT.exportModel( FormatIGES, "Output/linkrods.iges", shapes );
    
	clog << endl << "FormatSTEP: linkrods.step" << endl;
    TT.exportModel( FormatSTEP, "Output/linkrods.step", shapes );
    
	clog << endl << "FormatSTL: linkrods.stl" << endl;
    TT.exportModel( FormatSTL, "Output/linkrods.stl", shapes );
	
	clog << endl << "FormatVRML: linkrods.wrl" << endl;
	TT.exportModel( FormatVRML, "Output/linkrods.wrl", shapes );
	
	// *** The End ***
	
    clog << endl << "The End ImpExp hello!!!" << endl << endl;
    
    system("pause");
    return 0;
}


