#ifndef TRANSLATE_H
#define TRANSLATE_H

#include <string>

#include <TopTools_HSequenceOfShape.hxx>

#include <ShapeExtend_Explorer.hxx>

enum { FormatBREP, FormatIGES, FormatSTEP, FormatVRML, FormatSTL };

class Translate
{
	public:

	Translate();
	~Translate();

    Handle(TopTools_HSequenceOfShape) 	importModel( const int, const std::string& );
    virtual bool                      	exportModel( const int, const std::string&, const Handle(TopTools_HSequenceOfShape)& );
    
	private:

	// *** Import ***
	
	Handle(TopTools_HSequenceOfShape)	importBREP( const std::string& );
	Handle(TopTools_HSequenceOfShape)	importIGES( const std::string& );
	Handle(TopTools_HSequenceOfShape)	importSTEP( const std::string& );

	// *** Export ***
	
	bool exportBREP( const std::string&, const Handle(TopTools_HSequenceOfShape)& );
	bool exportIGES( const std::string&, const Handle(TopTools_HSequenceOfShape)& );
	bool exportSTEP( const std::string&, const Handle(TopTools_HSequenceOfShape)& );
	bool exportSTL ( const std::string&, const Handle(TopTools_HSequenceOfShape)& );
	bool exportVRML( const std::string&, const Handle(TopTools_HSequenceOfShape)& );

	bool checkFacetedBrep( const Handle(TopTools_HSequenceOfShape)& );
};

#endif

